Блог пользователя Endagorion

Автор Endagorion, история, 3 года назад, По-английски

Keeping track of both Codeforces round and online team contest was a doozy, so this is only the best draft of the editorial I have. Missing problems will gradually be added, and existing explanations may improve over time. Hope you enjoyed the problems, and let me know if anything can be explained better!

UPD: okay, all of the problems are out, and most of the bugs are fixed (I hope). By the way, we had a nice discussion with Errichto on his stream about Div. 2 problems, which some of you may find more approachable. Be sure to check it out, as well as other stuff Errichto creates!

Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...

(Kudos to Golovanov399 for his neat grid drawing tool)

Tutorial is loading...
Разбор задач Codeforces Round 691 (Div. 1)
Разбор задач Codeforces Round 691 (Div. 2)
  • Проголосовать: нравится
  • +217
  • Проголосовать: не нравится

»
3 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

https://codeforces.com/contest/1459/submission/101773389 Why my solution fails in test case 21 . problem div2c

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +15 Проголосовать: не нравится

    No clue what you're trying to do with the mod 3s. Try checking other's solutions for a simpler answer.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    5 1 1 5 9 3 3 1

    Try this test with your code and you'll get 4 as result, which is not correct. The reason it doesn't work is because you didn't count a[3] — a[2] while calculating the gcd of all (a[i] — a[i — 1])

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone explain why the property used in Problem C is also valid for multiple arguments?

  • »
    »
    3 года назад, # ^ |
    Rev. 2   Проголосовать: нравится +83 Проголосовать: не нравится

    We can show these properties by definition of $$$\gcd$$$.

    • $$$\gcd(a, b) = \gcd(a, b-a)$$$
    • $$$\gcd(a, b, c) = \gcd(a, \gcd(b, c)) = \gcd(\gcd(a, b), c)$$$

    Then we can extend our claim to multiple arguments by mathematical induction.

    $$$ \gcd(a_1, a_2, \cdots, a_{n-2}, a_{n-1}, a_n) \\ = \gcd(a_1, a_2, \cdots, a_{n-2}, \gcd(a_{n-1}, a_n)) \\ = \gcd(a_1, a_2, \cdots, a_{n-2}, \gcd(a_{n-1}, a_n-a_{n-1})) \\ = \gcd(a_1, a_2, \cdots, a_{n-2}, a_{n-1}, a_n-a_{n-1}) \\ = \gcd(a_1, a_2, \cdots, \gcd(a_{n-2}, a_{n-1}), a_n-a_{n-1}) \\ = \gcd(a_1, a_2, \cdots, \gcd(a_{n-2}, a_{n-1}-a_{n-2}), a_n-a_{n-1}) \\ = \gcd(a_1, a_2, \cdots, a_{n-2}, a_{n-1}-a_{n-2}, a_n-a_{n-1}) \\ \cdots \\ = \gcd(a_1, a_2-a_1, \cdots, a_{n-1}-a_{n-2}, a_n-a_{n-1}) $$$

    Therefore $$$\gcd(a_1 + b_j, a_2 + b_j, \cdots, a_{n-1} + b_j, a_n + b_j)$$$ is equal to $$$\gcd(a_1 + b_j, a_2-a_1, \cdots, a_{n-1}-a_{n-2}, a_n-a_{n-1})$$$.

    Update: We do not need to choose adjacent differences. $$$\gcd(a_1, a_2, \cdots, a_{n-2}, a_{n-1}, a_n)$$$ is also equal to $$$\gcd(a_1, a_2-a_1, \cdots, a_{n-1}-a_1, a_n-a_1)$$$, which can be proved similarly. The important step is to express all but one integers as $$$a_i - a_j$$$ to negate $$$+b_j$$$.

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

why someone's submissions been skipped and receive no message

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I didn't know the proof for problem B's solution but i solved it.

»
3 года назад, # |
Rev. 2   Проголосовать: нравится +3 Проголосовать: не нравится

Endagorion Please add implementations to the problems as well it will be really helpful.

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Solution sequence for Div2B is also available on OEIS. https://oeis.org/A241496. But I didn't understand the general formula. Can someone explain?

»
3 года назад, # |
  Проголосовать: нравится +40 Проголосовать: не нравится

https://youtu.be/1OWGTQpfk5Y — recording of post-contest discussion with Endagorion with analysis of all div2 problems (so up to div1-D)

»
3 года назад, # |
Rev. 2   Проголосовать: нравится +12 Проголосовать: не нравится

In problem D (div. 2) isn't the complexity O(n * k * n * A) where A the maximum capacity of a glass? Which in turn is 100^4 (since max n = 100 max k = 100 and max A = 100 )? 100^4 = 100 000 000 dp cells, so the solution should pass yes (with the memory optimization). But your complexity is O(n * k * n * A) I don't get how you got A^2 in there. Please someone explain, thanks.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +7 Проголосовать: не нравится

    Good point, thanks. I'll fix it soon.

    • »
      »
      »
      3 года назад, # ^ |
      Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

      That fix created some confusion.

      A line above that, $$$A$$$ was used to denote the 'total capacity of the subset'. In the next line, $$$A$$$ is used to denote the 'maximum capacity of the glass'.

»
3 года назад, # |
Rev. 3   Проголосовать: нравится +6 Проголосовать: не нравится

In Problem-B's explanation,

Last Line:

Shouldn't it be where k=n/2 rounded up, instead of where k=n/2 rounded down?

Endagorion

Someone, do correct me if I am wrong.

»
3 года назад, # |
Rev. 2   Проголосовать: нравится +5 Проголосовать: не нравится

Endagorion I think that in Problem-E's(div2) explanation

$$$p'$$$ should be equal to $$$v_0 + iv_x + jv_y + kv_z$$$ instead of $$$v_0 + xv_x + yv_y + zv_z$$$

this is part of the paragraph before the last one

Sorry if I am wrong.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится +3 Проголосовать: не нравится

    You are correct! I'll be fixing all mistakes soon once I finish the editorial for div1F.

»
3 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Why did the rating change again as it was? Endagorion

»
3 года назад, # |
  Проголосовать: нравится +25 Проголосовать: не нравится

Ignoring the short contest time and difficulty gap, I think your rounds are generally of high quality.

Thanks for the round :)

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Auto comment: topic has been updated by Endagorion (previous revision, new revision, compare).

»
3 года назад, # |
Rev. 4   Проголосовать: нравится +8 Проголосовать: не нравится

Is there a thought process on how to obtain the key observation of 'Latin Square'? It feels very clever and beautiful, but hard to come up with at the same time

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In problem D(Glass half spilled), can anybody tell me , why we are considering taken glasses from n to 1 order.

  • »
    »
    3 года назад, # ^ |
    Rev. 4   Проголосовать: нравится +1 Проголосовать: не нравится

    Edit : The order of $$$k$$$ doesn't matter too, since we allocate $$$n$$$ 2D dp arrays for each glasses. Sorry!

    We need to calculate $$$dp(i,k,A)$$$ from $$$k=n$$$ to $$$k=1$$$ and from $$$A=sum$$$ to $$$A=0$$$ order because if we do the opposite, 'duplication' will happen in case you use the same $$$dp$$$ table for all glasses. The order of $$$i$$$ doesn't matter, I think you can do either 1 to $$$n$$$ or vice versa.

    • »
      »
      »
      3 года назад, # ^ |
      Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

      Can someone explain this? I also dont understand the need to iterate backwards.

      101822812 Saw this submission, this proceeds in forward direction. So I guess we can proceed both ways.

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        yeah, can anyone please explain why do we need to iterate backwards? Thanks in advance :)

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Would the order of $$$A$$$ matter even if you're using $$$n$$$ 2D Arrays?

      I'm able to get the solution following the correct ordering with only one 2D array, but I thought that the order wouldn't matter if I used a separate 2D array for each i (since there is nothing to duplicate / overwrite).

      Can someone explain why this submission with $$$n$$$ 2D arrays gets a wrong answer? https://codeforces.com/contest/1459/submission/101994708

      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Never mind, figured it out by looking at the submission mentioned above.

        The order indeed doesn't matter but I need to make sure that I copy over all the values from the previous array.

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

How is the graph structured in Flip and Reverse F? The editorial makes it look like something on a straight line, which cant be true

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    That's exactly what it looks like though: vertices are balance values in the real line.

»
3 года назад, # |
  Проголосовать: нравится +8 Проголосовать: не нравится

Can Div2D/Div1B be solved using a top-down approach? Recursion with memoization?

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Is almost the same as in the tutorial, think it like knapsack: If we fix a total capacity A_s, a total number of glasses that we are going to fill K_s and a current glass i.We have to choices:

    1. Include the glass among the ones we are going to fill: This is possible if we haven't include all the glasses already and we are not exceeding the capacity. In this case we should decrease k_s by 1, because we are including one more glass, and also decrease A_s by the capacity of the current glass. Then just call the recursive function adding the amount of water of the current glass (just like the dp in the tutorial).
    2. Not including it: In this case we ignore the current glass, thus we just call the recursion with a different glass.

    In order to find the solution for a k just iterate over all possible capacities (I did it from 0 to the total capacity of all glasses) and the answer will be the maximum value of min(current_capacity, dp[start_index][current_k][current_capacity] / 2 + total_water_of_all_glasses / 2). Here is my submission 102646662

»
3 года назад, # |
  Проголосовать: нравится +15 Проголосовать: не нравится

Finally finished my alternative solution for div1D.

  • Consider the sequence of $$$N+1$$$ prefix differences (number of 1 minus number of 0). The given operation is just reversing a contiguous subsequence between two equal values.
  • Find ranges between equal values for the initial sequence of differences, merge overlapping/touching ranges. We can treat the resulting disjoint ranges independently since a reverse within one of them can't affect the rest.
  • What does an "optimal" result look like? There's no reversible substring starting and ending with 1, so when we throw away leading and trailing 0-s, we must get a string like 1...101...101...1. Proof left to the reader. (Alternatively, we can have no possible operation even at the start.)
  • For each of our substrings corresponding to disjoint ranges, we should be able to achieve this "optimal" situation. Turns out that the final string is now uniquely determined. Let's say that at the end, there are $$$a$$$ leading 0-s, $$$b$$$ trailing 0-s and a string starting and ending with 1 in between.
  • Let's look at the minimum of our sequence of differences. If it's equal to the final difference, then $$$b \gt 0$$$. Proceed recursively without the last 0.
  • Otherwise, the final difference is strictly not the minimum. That means the minimum difference is $$$-a$$$. We know $$$a$$$, time to remove the leading 0-s and proceed recursively again with $$$a=0$$$.
  • Let's look at the maximum difference. That's reached after the last 1. Now $$$b$$$ = maximum difference — final difference.
  • Now $$$a = 0$$$ and $$$b = 0$$$. If the minimum difference is unique, the final string must start with "1(1)", let's remove the leading 1 and again proceed recursively. Otherwise, it must start with "10".
  • All cases are covered and we can find the answer in $$$O(N)$$$.
»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone please help me understand the proof why we can convert any two Eulerian pathS with the operation of reversing a cycle ?

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In problem b if r = 51 and b = 61, then blue will win. But when r = 51 and b = 16 then they will end up equal. Am I missing something?

»
3 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

does anyone know the proof of this property of gcd? GCD(x,y)=GCD(x−y,y) or any resource for exlanation?

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can anyone explain me the DP solution of div2-B...Please

»
3 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In problem D why is the total available capacity necessary as a state ?

»
3 года назад, # |
Rev. 3   Проголосовать: нравится 0 Проголосовать: не нравится

For 1459D - Glass Half Spilled

When I used int for integer variables, I got a runtime error. 107625846

However, when I replaced all int's with int16_t, it gave AC. 107680750

This is the first time I've encountered something like this. Is there a way to avoid runtime error without using int16_t?

»
3 года назад, # |
  Проголосовать: нравится +10 Проголосовать: не нравится

Problem C can be solved using following identities

Instead $$$L$$$ write it as $$$R^{-1}$$$ and instead of $$$U$$$ write it as $$$D^{-1}$$$

  • $$$ID = DI$$$
  • $$$CR = RC$$$
  • $$$II$$$ is identity
  • $$$CC$$$ is identity
  • $$$IC = TI$$$ and $$$CI = TC$$$ where $$$T$$$ is the transpose operation
  • $$$IR^{k}I$$$ and $$$CD^{k}C$$$ are same as adding $$$k$$$ to each entry and taking $$$\mod n$$$.

Using these identities, we can reduce the whole expression to an expression where there is atmost one $$$I$$$ or $$$C$$$ and at most one transpose and rest $$$R$$$, $$$D$$$ and add operations which freely commute with each other.